#ifndef _PKTTOOLS_ASM_FIELD_H_INCLUDED_
#define _PKTTOOLS_ASM_FIELD_H_INCLUDED_

typedef enum {
  PKT_ASM_FIELD_NONE,

  PKT_ASM_FIELD_ETHERNET_DST_ADDR,
  PKT_ASM_FIELD_ETHERNET_SRC_ADDR,
  PKT_ASM_FIELD_ETHERNET_TYPE,
  PKT_ASM_FIELD_ETHERNET_VLAN_TAG,
  PKT_ASM_FIELD_ETHERNET_DATA,

  PKT_ASM_FIELD_ARP_HARDWARE,
  PKT_ASM_FIELD_ARP_PROTOCOL,
  PKT_ASM_FIELD_ARP_HARDWARE_SIZE,
  PKT_ASM_FIELD_ARP_PROTOCOL_SIZE,
  PKT_ASM_FIELD_ARP_OPERATION,
  PKT_ASM_FIELD_ARP_SENDER_MACADDR,
  PKT_ASM_FIELD_ARP_SENDER_IPADDR,
  PKT_ASM_FIELD_ARP_TARGET_MACADDR,
  PKT_ASM_FIELD_ARP_TARGET_IPADDR,

  PKT_ASM_FIELD_ICMP_TYPE,
  PKT_ASM_FIELD_ICMP_CODE,
  PKT_ASM_FIELD_ICMP_CHECKSUM,
  PKT_ASM_FIELD_ICMP_DATA,

  PKT_ASM_FIELD_IGMP_TYPE,
  PKT_ASM_FIELD_IGMP_CODE,
  PKT_ASM_FIELD_IGMP_CHECKSUM,
  PKT_ASM_FIELD_IGMP_GROUP,
  PKT_ASM_FIELD_IGMP_DATA,

  PKT_ASM_FIELD_TCP_SRC_PORT,
  PKT_ASM_FIELD_TCP_DST_PORT,
  PKT_ASM_FIELD_TCP_SEQ_NUMBER,
  PKT_ASM_FIELD_TCP_ACK_NUMBER,
  PKT_ASM_FIELD_TCP_OFFSET,
  PKT_ASM_FIELD_TCP_FLAGS,
  PKT_ASM_FIELD_TCP_WINDOW,
  PKT_ASM_FIELD_TCP_CHECKSUM,
  PKT_ASM_FIELD_TCP_URGENT,
  PKT_ASM_FIELD_TCP_DATA,

  PKT_ASM_FIELD_UDP_SRC_PORT,
  PKT_ASM_FIELD_UDP_DST_PORT,
  PKT_ASM_FIELD_UDP_SIZE,
  PKT_ASM_FIELD_UDP_CHECKSUM,
  PKT_ASM_FIELD_UDP_DATA,

  PKT_ASM_FIELD_IP_VERSION,
  PKT_ASM_FIELD_IP_HEADER_SIZE,
  PKT_ASM_FIELD_IP_TOS,
  PKT_ASM_FIELD_IP_TOTAL_SIZE,
  PKT_ASM_FIELD_IP_ID,
  PKT_ASM_FIELD_IP_FRAGMENT,
  PKT_ASM_FIELD_IP_TTL,
  PKT_ASM_FIELD_IP_PROTOCOL,
  PKT_ASM_FIELD_IP_CHECKSUM,
  PKT_ASM_FIELD_IP_SRC_ADDR,
  PKT_ASM_FIELD_IP_DST_ADDR,
  PKT_ASM_FIELD_IP_DATA,

  PKT_ASM_FIELD_ICMPV6_TYPE,
  PKT_ASM_FIELD_ICMPV6_CODE,
  PKT_ASM_FIELD_ICMPV6_CHECKSUM,
  PKT_ASM_FIELD_ICMPV6_DATA,

  PKT_ASM_FIELD_IPV6_VERSION,
  PKT_ASM_FIELD_IPV6_FLOWID,
  PKT_ASM_FIELD_IPV6_PAYLOAD_SIZE,
  PKT_ASM_FIELD_IPV6_NEXT_HEADER,
  PKT_ASM_FIELD_IPV6_HOP_LIMIT,
  PKT_ASM_FIELD_IPV6_SRC_ADDR,
  PKT_ASM_FIELD_IPV6_DST_ADDR,
  PKT_ASM_FIELD_IPV6_EXT_SIZE,
  PKT_ASM_FIELD_IPV6_EXT_DATA,
  PKT_ASM_FIELD_IPV6_DATA,
} pkt_asm_field_t;

char *pkt_asm_field_get_key(pkt_asm_field_t field);
pkt_asm_val_type_t pkt_asm_field_get_type(pkt_asm_field_t field);
pkt_asm_field_t pkt_asm_field_search_field_from_key(char *key);
int pkt_asm_field_output_key_list(FILE *fp, char *header);

#endif
